/*
CVE Services API

The CVE Services API supports automation tooling for the CVE Program. Credentials are     required for most service endpoints. Representatives of     <a href='https://www.cve.org/ProgramOrganization/CNAs'>CVE Numbering Authorities (CNAs)</a> should     use one of the methods below to obtain credentials:    <ul><li>If your organization already has an Organizational Administrator (OA) account for the CVE     Services, ask your admin for credentials</li>     <li>Contact your Root (<a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/Google'>Google</a>,     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/INCIBE'>INCIBE</a>,     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/jpcert'>JPCERT/CC</a>, or     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/redhat'>Red Hat</a>) or     Top-Level Root (<a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/icscert'>CISA ICS</a>     or <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/mitre'>MITRE</a>) to request credentials     </ul>     <p>CVE data is to be in the JSON 5.0 CVE Record format. Details of the JSON 5.0 schema are     located <a href='https://github.com/CVEProject/cve-schema/tree/master/schema/v5.0' target='_blank'>here</a>.</p>    <a href='https://cveform.mitre.org/' class='link' target='_blank'>Contact the CVE Services team</a>

API version: 2.1.4
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package cveapi

import (
	"encoding/json"
)

// checks if the CreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInnerSupportingMediaInner type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &CreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInnerSupportingMediaInner{}

// CreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInnerSupportingMediaInner struct for CreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInnerSupportingMediaInner
type CreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInnerSupportingMediaInner struct {
	// RFC2046 compliant IANA Media type for eg., text/markdown, text/html.
	Type string `json:"type"`
	// If true then the value field contains the media data encoded in base64. If false then the value field contains the UTF-8 media content.
	Base64 *bool `json:"base64,omitempty"`
	// Supporting media content, up to 16K. If base64 is true, this field stores base64 encoded data.
	Value string `json:"value"`
}

// NewCreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInnerSupportingMediaInner instantiates a new CreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInnerSupportingMediaInner object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInnerSupportingMediaInner(type_ string, value string) *CreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInnerSupportingMediaInner {
	this := CreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInnerSupportingMediaInner{}
	this.Type = type_
	var base64 bool = false
	this.Base64 = &base64
	this.Value = value
	return &this
}

// NewCreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInnerSupportingMediaInnerWithDefaults instantiates a new CreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInnerSupportingMediaInner object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInnerSupportingMediaInnerWithDefaults() *CreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInnerSupportingMediaInner {
	this := CreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInnerSupportingMediaInner{}
	var base64 bool = false
	this.Base64 = &base64
	return &this
}

// GetType returns the Type field value
func (o *CreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInnerSupportingMediaInner) GetType() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Type
}

// GetTypeOk returns a tuple with the Type field value
// and a boolean to check if the value has been set.
func (o *CreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInnerSupportingMediaInner) GetTypeOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Type, true
}

// SetType sets field value
func (o *CreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInnerSupportingMediaInner) SetType(v string) {
	o.Type = v
}

// GetBase64 returns the Base64 field value if set, zero value otherwise.
func (o *CreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInnerSupportingMediaInner) GetBase64() bool {
	if o == nil || IsNil(o.Base64) {
		var ret bool
		return ret
	}
	return *o.Base64
}

// GetBase64Ok returns a tuple with the Base64 field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInnerSupportingMediaInner) GetBase64Ok() (*bool, bool) {
	if o == nil || IsNil(o.Base64) {
		return nil, false
	}
	return o.Base64, true
}

// HasBase64 returns a boolean if a field has been set.
func (o *CreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInnerSupportingMediaInner) HasBase64() bool {
	if o != nil && !IsNil(o.Base64) {
		return true
	}

	return false
}

// SetBase64 gets a reference to the given bool and assigns it to the Base64 field.
func (o *CreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInnerSupportingMediaInner) SetBase64(v bool) {
	o.Base64 = &v
}

// GetValue returns the Value field value
func (o *CreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInnerSupportingMediaInner) GetValue() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Value
}

// GetValueOk returns a tuple with the Value field value
// and a boolean to check if the value has been set.
func (o *CreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInnerSupportingMediaInner) GetValueOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Value, true
}

// SetValue sets field value
func (o *CreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInnerSupportingMediaInner) SetValue(v string) {
	o.Value = v
}

func (o CreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInnerSupportingMediaInner) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o CreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInnerSupportingMediaInner) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["type"] = o.Type
	if !IsNil(o.Base64) {
		toSerialize["base64"] = o.Base64
	}
	toSerialize["value"] = o.Value
	return toSerialize, nil
}

type NullableCreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInnerSupportingMediaInner struct {
	value *CreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInnerSupportingMediaInner
	isSet bool
}

func (v NullableCreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInnerSupportingMediaInner) Get() *CreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInnerSupportingMediaInner {
	return v.value
}

func (v *NullableCreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInnerSupportingMediaInner) Set(val *CreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInnerSupportingMediaInner) {
	v.value = val
	v.isSet = true
}

func (v NullableCreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInnerSupportingMediaInner) IsSet() bool {
	return v.isSet
}

func (v *NullableCreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInnerSupportingMediaInner) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInnerSupportingMediaInner(val *CreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInnerSupportingMediaInner) *NullableCreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInnerSupportingMediaInner {
	return &NullableCreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInnerSupportingMediaInner{value: val, isSet: true}
}

func (v NullableCreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInnerSupportingMediaInner) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCreateCveRecordRejectionResponseCreatedContainersCnaRejectedReasonsInnerSupportingMediaInner) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


